type lcell  == (int*int) list;;
type formule = Rien | Somme of lcell;;
type tableau = {
          n  : int; p:int;        (* dimensions            *)
          v  : int vect vect;     (* valeurs des cellules  *)
          f  : formule vect vect; (* formules              *)
          dep: int vect vect;     (* nombre de dpendances *)
          suc: lcell vect vect;   (* successeurs           *)
  mutable lt : lcell              (* ordre de calcul       *)
};;

let t = {
  n = 3; p = 3;
  v = [| [|1;2;3|];
         [|4;5;6|];
         [|7;8;9|] |];
  f = [| [|Rien;            Somme[2,2];      Somme[0,0]      |];
         [|Somme[2,0; 2,0]; Somme[2,0; 2,2]; Somme[1,0; 2,1] |];
         [|Somme[0,2];      Somme[1,1; 0,1]; Rien            |] |];
  dep = make_matrix 3 3 0;
  suc = make_matrix 3 3 [];
  lt  = []
};;

let compte_dpendances(t) =
  for i=0 to t.n-1 do for j=0 to t.p-1 do t.dep.(i).(j) <- 0 done done;
  for i=0 to t.n-1 do for j=0 to t.p-1 do
    match t.f.(i).(j) with
    | Rien -> ()
    | Somme(liste) ->
	t.dep.(i).(j) <- t.dep.(i).(j) + list_length(liste);
	do_list (fun (k,l) -> t.suc.(k).(l) <- (i,j) :: t.suc.(k).(l)) liste
  done done
;;

let rec place t (i,j) =
  t.lt <- (i,j) :: t.lt;
  do_list (dcompte t) t.suc.(i).(j)

and dcompte t (i,j) =
  t.dep.(i).(j) <- t.dep.(i).(j) - 1;
  if t.dep.(i).(j) = 0 then place t (i,j)
;;

let tri_topo(t) =
  compte_dpendances(t);
  let l = ref [] in
  for i=0 to t.n-1 do for j=0 to t.p-1 do match t.f.(i).(j) with
    | Rien -> l := (i,j) :: !l
    | _ -> ()
  done done;
  t.lt <- [];
  do_list (place t) !l;
  t.lt <- rev(t.lt)
;;

let calcule t (i,j) = match t.f.(i).(j) with
  | Rien -> ()
  | Somme(liste) ->
      t.v.(i).(j) <- 0;
      do_list (fun (k,l) -> t.v.(i).(j) <- t.v.(i).(j) + t.v.(k).(l)) liste
;;

(* essai *)
tri_topo(t);;
do_list (calcule t) t.lt;;
t.v;;
